#include "signaldemo.h"
#include <QSlider>
#include <QSpinBox>
#include <QPushButton>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QMessageBox>

SignalDemo::SignalDemo(QWidget *parent)
    : QWidget(parent)
{
    setupForm();
}

void SignalDemo::setupForm(){
    QVBoxLayout *lMain = new QVBoxLayout;
    QHBoxLayout *lTop = new QHBoxLayout;
    slider = new QSlider;
    slider->setObjectName("mySlider");
    slider->setOrientation(Qt::Horizontal);
    slider->setRange(0, 100);
    slider->setValue(42);
    spinBox = new QSpinBox;
    spinBox->setObjectName("mySpinBox");
    spinBox->setRange(0, 100);
    spinBox->setValue(42);
    btnQuit = new QPushButton(tr("&Quit"));
    lTop->addWidget(slider);
    lTop->addWidget(spinBox);

    lMain->addLayout(lTop);
    lMain->addStretch();
    lMain->addWidget(btnQuit);
    this->setLayout(lMain);

    setWindowTitle(tr("Signal and slot demonstration"));
    connect(slider, SIGNAL(valueChanged(int)), spinBox,
            SLOT(setValue(int)));
    connect(slider, SIGNAL(valueChanged(int)), this,
            SLOT(checkMinMax(int)));
    connect(spinBox, SIGNAL(valueChanged(int)), slider,
            SLOT(setValue(int)));
    //connect(btnQuit, SIGNAL(clicked()), this, SLOT(close()));
    connect(btnQuit, SIGNAL(clicked()), this, SLOT(readyToQuit()));
    this->dumpObjectTree();
}

void SignalDemo::checkMinMax(int x){
    qDebug() << x;
    if(x == slider->maximum()){
        QMessageBox::information(this, tr("Information"),
                                 tr("Maximum has been reached"));
    } else
        if(x == slider->minimum()){
            QMessageBox::information(this, tr("Information"),
                                     tr("Minimuum has been reached"));
        }
}

void SignalDemo::readyToQuit(){
    emit quitting();
}

SignalDemo::~SignalDemo()
{
}

